/*
 * Copyright 2017 Arne Vajhj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.vms.call.lib;

/**
 * Class VMSCodes has all the item codes and other input values for system services and RTL functions.
 * 
 * See VMS documentation for semantics.
 */
public class VMSCodes {
	/* DVI codes */
	public static final int DVI$_DEVTYPE = 6;
	public static final int DVI$_ERRCNT = 20;
	public static final int DVI$_MAXBLOCK = 26;
	public static final int DVI$_VOLNAM = 34;
	public static final int DVI$_FREEBLOCKS = 42;
	/* JPI codes */
	public static final int JPI$_PRI = 770;
	public static final int JPI$_UIC = 772;
	public static final int JPI$_STATE = 774;
	public static final int JPI$_PID = 793;
	public static final int JPI$_PRCNAM = 796;
	public static final int JPI$_TERMINAL = 797;
	public static final int JPI$_MODE = 802;
	public static final int JPI$_NODENAME = 809;
	public static final int JPI$_CURPRIV = 1024;
	public static final int JPI$_CPUTIM = 1031;
	public static final int JPI$_DIRIO = 1035;
	public static final int JPI$_BUFIO = 1036;
	public static final int JPI$_WSSIZE = 1041;
	public static final int JPI$_USERNAME = 514;
	public static final int JPI$_LOGINTIM = 518;
	public static final int JPI$_IMAGNAME = 519;
	/* PSCAN codes */
	public static final int PSCAN$_MASTER_PID = 9;
	public static final int PSCAN$_NODENAME = 13;
	public static final int PSCAN$_OWNER = 14;
	public static final int PSCAN$_PRCNAM = 16;
	public static final int PSCAN$_TERMINAL = 21;
	public static final int PSCAN$_USERNAME = 23;
	/* PSCAN flags */
	public static final int PSCAN$M_WILDCARD = 0x100;
	/* UAI codes */
	public static final int UAI$_USERNAME = 4;
	public static final int UAI$_UIC = 6;
	public static final int UAI$_ACCOUNT = 11;
	public static final int UAI$_OWNER = 12;
	public static final int UAI$_DEFDEV = 13;
	public static final int UAI$_DEFDIR = 14;
	public static final int UAI$_PWD = 18;
	public static final int UAI$_LOGFAILS = 20;
	public static final int UAI$_SALT = 21;
	public static final int UAI$_ENCRYPT = 22;
	public static final int UAI$_PWD_DATE = 27;
	public static final int UAI$_PRIV = 31;
	public static final int UAI$_DEF_PRIV = 32;
	public static final int UAI$_PRI = 47;
	public static final int UAI$_MAXJOBS = 49;
	public static final int UAI$_PRCCNT = 52;
	public static final int UAI$_WSQUOTA = 60;
	public static final int UAI$_WSEXTENT = 62;
	public static final int UAI$_PGFLQUOTA = 63;
	/* LNM codes */
	public static final int LNM$_STRING = 2;
	public static final int LNM$_ATTRIBUTES = 3;
	public static final int LNM$_TABLE = 4;
	public static final int LNM$_LENGTH = 5;
	public static final int LNM$_ACMODE = 6;
	/* IO codes */
    public static final int IO$_WRITEPBLK = 11;
    public static final int IO$_READPBLK = 12;
    public static final int IO$_WRITELBLK = 32;
    public static final int IO$_READLBLK = 33;
    public static final int IO$_SETMODE = 35;
    public static final int IO$_SENSEMODE = 39;
    public static final int IO$_WRITEOF = 40;
    public static final int IO$_WRITEVBLK = 48;
    public static final int IO$_READVBLK = 49;
    public static final int IO$_ACCESS = 50;
    public static final int IO$_CREATE = 51;
    public static final int IO$_DEACCESS = 52;
    public static final int IO$_DELETE = 53;
    public static final int IO$_MODIFY = 54;
    public static final int IO$_MOUNT = 57;
	/* IO flags */
    public static final int IO$M_ACCESS = 0x0040;
    public static final int IO$M_CREATE = 0x0080;
    public static final int IO$M_DELETE = 0x0100;
    public static final int IO$M_MOUNT = 0x0200;
    public static final int IO$M_DMOUNT = 0x0400;
    public static final int IO$M_REMOUNT = 0x0800;
    public static final int IO$M_MOVEFILE = 0x1000;
    public static final int IO$M_RWSHELVED = 0x4000;
    public static final int IO$M_BINARY = 0x0040;
    public static final int IO$M_PACKED = 0x0080;
    public static final int IO$M_NOW = 0x0040;
    public static final int IO$M_READATTN = 0x0080;
    public static final int IO$M_WRTATTN = 0x0100;
    public static final int IO$M_NOECHO = 0x0040;
    public static final int IO$M_TIMED = 0x0080;
    public static final int IO$M_NOFILTR = 0x0200;
    public static final int IO$M_DSABLMBX = 0x0400;
    public static final int IO$M_PURGE = 0x0800;
    public static final int IO$M_TRMNOECHO = 0x1000;
    public static final int IO$M_REFRESH = 0x2000;
    public static final int IO$M_ESCAPE = 0x4000;
    public static final int IO$M_EXTEND = 0x8000;
    public static final int IO$M_TYPEAHDCNT = 0x0040;
    public static final int IO$M_CTRLYAST = 0x0080;
    public static final int IO$M_CTRLCAST = 0x0100;
    public static final int IO$M_BRDCST = 0x4000;
    /* ACME codes */
    public static final int ACME$_FC_AUTHENTICATE_PRINCIPAL = 1;
    public static final int ACME$_FC_CHANGE_PASSWORD = 2;
    public static final int ACME$_LOGON_TYPE = 514;
    public static final int ACME$_NEW_PASSWORD_FLAGS = 515;
    public static final int ACME$_NEW_PASSWORD_1 = 8705;
    public static final int ACME$_NEW_PASSWORD_2 = 8706;
    public static final int ACME$_PASSWORD_1 = 8708;
    public static final int ACME$_PASSWORD_2 = 8709;
    public static final int ACME$_PRINCIPAL_NAME_IN = 8711;
    /* PRV masks */
    public static final long PRV$M_CMKRNL = 0x1L;
    public static final long PRV$M_CMEXEC = 0x2L;
    public static final long PRV$M_SYSNAM = 0x4L;
    public static final long PRV$M_GRPNAM = 0x8L;
    public static final long PRV$M_IMPERSONATE = 0x20L;
    public static final long PRV$M_DIAGNOSE = 0x40L;
    public static final long PRV$M_LOG_IO = 0x80L;
    public static final long PRV$M_GROUP = 0x100L;
    public static final long PRV$M_ACNT = 0x200L;
    public static final long PRV$M_PRMMBX = 0x800L;
    public static final long PRV$M_PSWAPM = 0x1000L;
    public static final long PRV$M_SETPRI = 0x2000L;
    public static final long PRV$M_SETPRV = 0x4000L;
    public static final long PRV$M_TMPMBX = 0x8000L;
    public static final long PRV$M_WORLD = 0x10000L;
    public static final long PRV$M_OPER = 0x40000L;
    public static final long PRV$M_EXQUOTA = 0x80000L;
    public static final long PRV$M_NETMBX = 0x100000L;
    public static final long PRV$M_PHY_IO = 0x400000L;
    public static final long PRV$M_PRMGLB = 0x01000000L;
    public static final long PRV$M_PFNMAP = 0x4000000L;
    public static final long PRV$M_SHMEM = 0x8000000L;
    public static final long PRV$M_SYSPRV = 0x10000000L;
    public static final long PRV$M_BYPASS = 0x20000000L;
    public static final long PRV$M_SYSLCK = 0x40000000L;
    public static final long PRV$M_GRPPRV = 0x400000000L;
    public static final long PRV$M_READALL = 0x800000000L;
	/* LBR operations */
	public static final int LBR$C_CREATE = 0;
	public static final int LBR$C_READ = 1;
	public static final int LBR$C_UPDATE = 2;
	/* LBR types */
	public static final int LBR$C_TYP_OBJ = 1;
	public static final int LBR$C_TYP_MLB = 2;
	public static final int LBR$C_TYP_HLP = 3;
	public static final int LBR$C_TYP_TXT = 4;
	/* control keys */
	public static final int LIB$M_CLI_CTRLT = 0x00100000;
	public static final int LIB$M_CLI_CTRLY = 0x02000000;
	/* symbol types */
	public static final int LIB$K_CLI_LOCAL_SYM = 1;
	public static final int LIB$K_CLI_GLOBAL_SYM = 2;
	/* float types */
	public static final int LIB$K_VAX_F = 0;
	public static final int LIB$K_VAX_D = 1;
	public static final int LIB$K_VAX_G = 2;
	public static final int LIB$K_VAX_H = 3;
	public static final int LIB$K_IEEE_S = 4;
	public static final int LIB$K_IEEE_T = 5;
	/* JPI mode types */
	public static final int JPI$K_OTHER = 0;
	public static final int JPI$K_NETWORK = 1;
	public static final int JPI$K_BATCH = 2;
	public static final int JPI$K_INTERACTIVE = 3;
	/* ACME access types */
    public static final int ACME$K_NETWORK = 1;
    public static final int ACME$K_BATCH = 2;
    public static final int ACME$K_LOCAL = 3;
    public static final int ACME$K_DIALUP = 4;
    public static final int ACME$K_REMOTE = 5;
    /* BRK types */
    public static final int BRK$C_DEVICE = 1;
    public static final int BRK$C_USERNAME = 2;
    public static final int BRK$C_ALLUSERS = 3;
    public static final int BRK$C_ALLTERMS = 4;
    /* LCK modes */
    public static final int LCK$K_NLMODE = 0;
    public static final int LCK$K_CRMODE = 1;
    public static final int LCK$K_CWMODE = 2;
    public static final int LCK$K_PRMODE = 3;
    public static final int LCK$K_PWMODE = 4;
    public static final int LCK$K_EXMODE = 5;
    /* LCK flags */
    public static final int LCK$M_VALBLK = 0x1;
    public static final int LCK$M_CONVERT = 0x2;
    public static final int LCK$M_NOQUEUE = 0x4;
    public static final int LCK$M_SYNCSTS = 0x8;
    public static final int LCK$M_SYSTEM = 0x10;
    public static final int LCK$M_RECOVER = 0x80;
    public static final int LCK$M_PROTECT = 0x100;
    public static final int LCK$M_NODLCKWT = 0x200;
    public static final int LCK$M_NODLCKBLK = 0x400;
    public static final int LCK$M_EXPEDITE = 0x800;
    public static final int LCK$M_QUECVT = 0x1000;
    public static final int LCK$M_XVALBLK = 0x10000;
    public static final int LCK$M_DEQALL = 0x1;
    public static final int LCK$M_CANCEL = 0x2;
    public static final int LCK$M_INVVALBLK = 0x4;
    /* QUI functions codes */
    public static final short QUI$_CANCEL_OPERATION = 1;
    public static final short QUI$_DISPLAY_CHARACTERISTIC = 2;
    public static final short QUI$_DISPLAY_FILE = 3;
    public static final short QUI$_DISPLAY_FORM = 4;
    public static final short QUI$_DISPLAY_JOB = 5;
    public static final short QUI$_DISPLAY_QUEUE = 6;
    public static final short QUI$_TRANSLATE_QUEUE = 7;
    public static final short QUI$_DISPLAY_ENTRY = 8;
    /* QUI item codes */
    public static final int QUI$_FILELIST = -1; /* pseudo code */
    public static final int QUI$_BASE_PRIORITY = 4;
    public static final int QUI$_CPU_LIMIT = 13;
    public static final int QUI$_DEVICE_NAME = 14;
    public static final int QUI$_ENTRY_NUMBER = 15;
    public static final int QUI$_FILE_SPECIFICATION = 21;
    public static final int QUI$_JOB_LIMIT = 43;
    public static final int QUI$_JOB_NAME = 44;
    public static final int QUI$_JOB_STATUS = 49;
    public static final int QUI$_LOG_SPECIFICATION = 53;
    public static final int QUI$_PRIORITY = 66;
    public static final int QUI$_QUEUE_FLAGS = 69;
    public static final int QUI$_QUEUE_NAME = 70;
    public static final int QUI$_QUEUE_STATUS = 71;
    public static final int QUI$_SEARCH_FLAGS = 76;
    public static final int QUI$_SEARCH_NAME = 77;
    public static final int QUI$_SEARCH_NUMBER = 78;
    public static final int QUI$_USERNAME = 81;
    public static final int QUI$_WSDEFAULT = 82;
    public static final int QUI$_WSEXTENT = 83;
    public static final int QUI$_WSQUOTA = 84;
    public static final int QUI$_FILE_IDENTIFICATION = 93;
    public static final int QUI$_EXECUTING_JOB_COUNT = 107;
    public static final int QUI$_PENDING_JOB_COUNT = 117;
    /* QUI flags */
    public static final int QUI$M_JOB_ABORTING = 0x1;
    public static final int QUI$M_JOB_EXECUTING = 0x2;
    public static final int QUI$M_JOB_HOLDING = 0x4;
    public static final int QUI$M_JOB_RESTARTING = 0x40;
    public static final int QUI$M_JOB_STARTING = 0x100;
    public static final int QUI$M_JOB_SUSPENDED = 0x400;
    public static final int QUI$M_JOB_PENDING = 0x800;
    public static final int QUI$M_JOB_STALLED = 0x2000;
    public static final int QUI$M_JOB_INCOMPLETE = 0x4000;
    public static final int QUI$M_JOB_COMPLETING = 0x8000;
    public static final int QUI$M_QUEUE_IDLE = 0x2;
    public static final int QUI$M_QUEUE_PAUSED = 0x10;
    public static final int QUI$M_QUEUE_PAUSING = 0x20;
    public static final int QUI$M_QUEUE_REMOTE = 0x40;
    public static final int QUI$M_QUEUE_RESETTING = 0x80;
    public static final int QUI$M_QUEUE_RESUMING = 0x100;
    public static final int QUI$M_QUEUE_STALLED = 0x400;
    public static final int QUI$M_QUEUE_STARTING = 0x800;
    public static final int QUI$M_QUEUE_STOPPED = 0x1000;
    public static final int QUI$M_QUEUE_STOPPING = 0x2000;
    public static final int QUI$M_QUEUE_UNAVAILABLE = 0x4000;
    public static final int QUI$M_QUEUE_CLOSED = 0x8000;
    public static final int QUI$M_QUEUE_BUSY = 0x10000;
    public static final int QUI$M_QUEUE_DISABLED =0x80000;
    public static final int QUI$M_SEARCH_ALL_JOBS = 0x1;
    public static final int QUI$M_SEARCH_WILDCARD = 0x2;
    public static final int QUI$M_SEARCH_BATCH = 0x4;
    public static final int QUI$M_SEARCH_THIS_JOB = 0x10;
    public static final int QUI$M_SEARCH_PRINTER = 0x20;
    public static final int QUI$M_SEARCH_SERVER = 0x40;
    public static final int QUI$M_SEARCH_TERMINAL = 0x80;
    public static final int QUI$M_SEARCH_GENERIC = 0x100;
    /* JBC function codes */
    public static final int SJC$_ABORT_JOB = 1;
    public static final int SJC$_ASSIGN_QUEUE = 5;
    public static final int SJC$_CREATE_QUEUE = 11;
    public static final int SJC$_DEASSIGN_QUEUE = 12;
    public static final int SJC$_DELETE_JOB = 17;
    public static final int SJC$_DELETE_QUEUE = 18;
    public static final int SJC$_ENTER_FILE = 19;
    public static final int SJC$_PAUSE_QUEUE = 21;
    public static final int SJC$_RESET_QUEUE = 22;
    public static final int SJC$_START_QUEUE = 24;
    public static final int SJC$_START_QUEUE_MANAGER = 25;
    public static final int SJC$_STOP_QUEUE = 27;
    public static final int SJC$_STOP_QUEUE_MANAGER = 28;
    public static final int SJC$_DELETE_QUEUE_MANAGER = 32;
    /* JBC items codes */
    public static final int SJC$_AFTER_TIME = 3;
    public static final int SJC$_BASE_PRIORITY = 7;
    public static final int SJC$_BATCH = 8;
    public static final int SJC$_CPU_DEFAULT = 19;
    public static final int SJC$_CPU_LIMIT = 21;
    public static final int SJC$_DELETE_FILE = 24;
    public static final int SJC$_DESTINATION_QUEUE = 26;
    public static final int SJC$_DEVICE_NAME = 27;
    public static final int SJC$_ENTRY_NUMBER = 30;
    public static final int SJC$_ENTRY_NUMBER_OUTPUT = 31;
    public static final int SJC$_FILE_COPIES = 35;
    public static final int SJC$_FILE_SPECIFICATION = 42;
    public static final int SJC$_GENERIC_QUEUE = 66;
    public static final int SJC$_JOB_LIMIT = 78;
    public static final int SJC$_JOB_NAME = 79;
    public static final int SJC$_LOG_SPECIFICATION = 98;
    public static final int SJC$_NOTIFY = 108;
    public static final int SJC$_PARAMETER_1 = 119;
    public static final int SJC$_PARAMETER_2 = 120;
    public static final int SJC$_PARAMETER_3 = 121;
    public static final int SJC$_PARAMETER_4 = 122;
    public static final int SJC$_PARAMETER_5 = 123;
    public static final int SJC$_PARAMETER_6 = 124;
    public static final int SJC$_PARAMETER_7 = 125;
    public static final int SJC$_PARAMETER_8 = 126;
    public static final int SJC$_PROCESSOR = 131;
    public static final int SJC$_QUEUE = 134;
    public static final int SJC$_RESTART = 138;
    public static final int SJC$_TERMINAL = 147;
    public static final int SJC$_WSDEFAULT = 151;
    public static final int SJC$_WSEXTENT = 153;
    public static final int SJC$_WSQUOTA = 155;
    public static final int SJC$_PRINTER = 175;
    public static final int SJC$_QUEUE_DESCRIPTION = 185;
    public static final int SJC$_QUEUE_MANAGER_NAME = 193;
    public static final int SJC$_QUEUE_MANAGER_NODES = 194;
    /* RMS block codes */
    public static final int FAB$C_BID = 3;
    public static final int RAB$C_BID = 1;
    public static final int NAM$C_BID = 2;
    /* FAB FOP flags */
    public static final int FAB$M_ASY = 0x01;
    public static final int FAB$M_TMP = 0x08;
    public static final int FAB$M_DLT = 0x8000;
    public static final int FAB$M_CTG = 0x100000;
    public static final int FAB$M_CBT = 0x200000;
    public static final int FAB$M_NAM = 0x01000000;
    /* FAB FAC flags */
    public static final int FAB$M_PUT = 0x01;
    public static final int FAB$M_GET = 0x02;
    public static final int FAB$M_DEL = 0x04;
    public static final int FAB$M_UPD = 0x08;
    public static final int FAB$M_TRN = 0x10;
    public static final int FAB$M_BIO = 0x20;
    /* FAB SHR flags */
    public static final int FAB$M_SHRPUT = 0x01;
    public static final int FAB$M_SHRGET = 0x02;
    public static final int FAB$M_SHRDEL = 0x04;
    public static final int FAB$M_SHRUPD = 0x08;
    /* FAB ORG values */
    public static final int FAB$C_SEQ = 0;
    public static final int FAB$C_REL = 16;
    public static final int FAB$C_IDX = 32;
    /* FAB RAT flags */
    public static final int FAB$M_FTN = 0x01;
    public static final int FAB$M_CR = 0x02;
    public static final int FAB$M_PRN = 0x04;
    /* FAB RFM values */
    public static final int FAB$C_UDF = 0;
    public static final int FAB$C_FIX = 1;
    public static final int FAB$C_VAR = 2;
    public static final int FAB$C_VFC = 3;
    public static final int FAB$C_STM = 4;
    public static final int FAB$C_STMLF = 5;
    public static final int FAB$C_STMCR = 6;
    /* RAB ROP flags */
    public static final int RAB$M_ASY = 0x01;
    public static final int RAB$M_EOF = 0x0100;
    public static final int RAB$M_RAH = 0x0200;
    public static final int RAB$M_WBH = 0x0400;
    public static final int RAB$M_BIO = 0x0800;
    public static final int RAB$M_KGE = 0x200000;
    public static final int RAB$M_KGT = 0x400000;
    /* RAB RAC values */
    public static final int RAB$C_SEQ = 0;
    public static final int RAB$C_KEY = 1;
    public static final int RAB$C_RFA = 2;
}
