/*
 * Copyright 2017 Arne Vajhj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.vms.call.test;

import static org.junit.Assert.*;

import org.junit.Test;

import dk.vajhoej.vms.call.VMSLibrary.Result;
import dk.vajhoej.vms.call.lib.SYS;
import dk.vajhoej.vms.call.lib.SYS.TERMINAL_IO;

public class TestLogon extends BaseTest {
	@Test
	public void testACMW() {
        try {
        	TERMINAL_IO chan = new SYS.TERMINAL_IO();
        	chan.SYS$ASSIGN();
        	chan.SYS$QIOW_puts("Enter username: ");
        	String un = chan.SYS$QIOW_gets().getResult();
        	chan.SYS$QIOW_puts("Enter password: ");
        	String pw = chan.SYS$QIOW_gets(false).getResult();
        	chan.SYS$DASSGN();
        	Result<Boolean> res = SYS.SYS$ACMW(un,  pw);        			
            assertVMSCall("SYS$ACMW", res.getStatus(), res.getResult());
        } catch(Exception ex) {
        	fail("Unexpected exception: " + ex);
        }
	}
}
